/*
 * WengoPhone, a voice over Internet phone
 * Copyright (C) 2004-2005  Wengo
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 * DirectX utils functions
 *
 * @author Mathieu Stute
 */

#ifndef WEBCAM_UTILS_WIN32_H
#define WEBCAM_UTILS_WIN32_H
	
#include <dshow.h>
#include <atlbase.h>
#include <qedit.h>
#include <comutil.h> // for _bstr_t

void webcam_dx_error(char * error);
void webcam_dx_log(char * mess);

CComPtr< IBaseFilter > GetCaptureDevice( char * device_name );
void GetDefaultCapDevice( IBaseFilter ** ppCap );
HRESULT FindMyCaptureDevice(IBaseFilter **pF, BSTR bstrName);

/**
* take a base filter and try to return a pointer to its IAMStreamConfig
 * @return a NULL pointer in the case it fails
 */
IAMStreamConfig * GetIAMStreamConfig( IBaseFilter *pFilter);

HRESULT ConnectFilters( IGraphBuilder *pGraph, IPin *pOut, IBaseFilter *pDest);
HRESULT ConnectFilters( IGraphBuilder *pGraph, IBaseFilter *pSrc, IBaseFilter *pDest);
HRESULT GetUnconnectedPin( IBaseFilter *pFilter, PIN_DIRECTION PinDir, IPin **ppPin);

#endif
